Package: primitive-types

## Class char

- - ### Methods Summary

    Methods
    Return type | Name and parameters
    --- | ---
    `boolean` | `asBoolean()` Coerces a char array to a boolean value.
    `boolean` | `contains(Object value)` Checks whether the array contains the given value.
    `Number` | `count(Object value)` Counts the number of occurrences of the given value inside this array.
    `Collection` | `flatten()` Flatten an array.
    `List` | `getAt(IntRange range)` Support the subscript operator with an IntRange for a char array
    `List` | `getAt(ObjectRange range)` Support the subscript operator with an ObjectRange for a char array
    `List` | `getAt(Range range)` Support the subscript operator with a range for a char array
    `List` | `getAt(Collection indices)` Support the subscript operator with a collection for a char array
    `String` | `join(String separator)` Concatenates the string representation of each items in this array, with the given String as a separator between each item.
    `int` | `size()` Allows arrays to behave similar to collections.
    `Stream` | `stream()` Returns a sequential Stream with the specified array as its source.
    `char` | `sum()` Sums the items in an array.
    `char` | `sum(char initialValue)` Sums the items in an array, adding the result to some initial value.
    `char[]` | `swap(int i, int j)` Swaps two elements at the specified positions.
    `List` | `toList()` Converts this array to a List of the same size, with each element added to the list.
    `Set` | `toSet()` Converts this array to a Set, with each unique element added to the set.
    `String` | `toString()` Returns the string representation of the given array.

- - ### Methods Detail

    - #### public boolean asBoolean()

      Coerces a char array to a boolean value. A char array is false if the array is of length 0, and true otherwise.

      Returns:
        the array's boolean value
      Since:
        1.7.4

    - #### public boolean contains(Object value)

      Checks whether the array contains the given value.

      Parameters:
        `value` - the value being searched for
      Returns:
        true if the array contains the value
      Since:
        1.8.6

    - #### public Number count(Object value)

      Counts the number of occurrences of the given value inside this array. Comparison is done using Groovy's == operator (using `compareTo(value) == 0` or `equals(value)` ).

      Parameters:
        `value` - the value being searched for
      Returns:
        the number of occurrences
      Since:
        1.6.4

    - #### public Collection flatten()

      Flatten an array. This array and any nested arrays or collections have their contents (recursively) added to the new collection.

      Returns:
        a flattened Collection
      Since:
        1.6.0

    - #### public List getAt(IntRange range)

      Support the subscript operator with an IntRange for a char array

      Parameters:
        `range` - an IntRange indicating the indices for the items to retrieve
      Returns:
        list of the retrieved chars
      Since:
        1.0

    - #### public List getAt(ObjectRange range)

      Support the subscript operator with an ObjectRange for a char array

      Parameters:
        `range` - an ObjectRange indicating the indices for the items to retrieve
      Returns:
        list of the retrieved chars
      Since:
        1.0

    - #### public List getAt(Range range)

      Support the subscript operator with a range for a char array

      Parameters:
        `range` - a range indicating the indices for the items to retrieve
      Returns:
        list of the retrieved chars
      Since:
        1.5.0

    - #### public List getAt(Collection indices)

      Support the subscript operator with a collection for a char array

      Parameters:
        `indices` - a collection of indices for the items to retrieve
      Returns:
        list of the chars at the given indices
      Since:
        1.0

    - #### public String join(String separator)

      Concatenates the string representation of each items in this array, with the given String as a separator between each item.

      Parameters:
        `separator` - a String separator
      Returns:
        the joined String
      Since:
        2.4.1

    - #### public int size()

      Allows arrays to behave similar to collections.

      Returns:
        the length of the array
      Since:
        1.0
      See Also:
        Array#getLength(java.lang.Object)

    - #### public Stream stream()

      Returns a sequential Stream with the specified array as its source.

      Returns:
        a `Stream` for the array

    - #### public char sum()

      Sums the items in an array.

          assert (1+2+3+4 as char) == ([1,2,3,4] as char[]).sum()

      Returns:
        The sum of all of the items
      Since:
        2.4.2

    - #### public char sum(char initialValue)

      Sums the items in an array, adding the result to some initial value.

          assert (5+1+2+3+4 as char) == ([1,2,3,4] as char[]).sum(5 as char)

      Parameters:
        `initialValue` - the items in the array will be summed to this initial value
      Returns:
        The sum of all of the items.
      Since:
        2.4.2

    - #### public char[] swap(int i, int j)

      Swaps two elements at the specified positions.

      Example:

          assert ([1, 3, 2, 4] as char[]) == ([1, 2, 3, 4] as char[]).swap(1, 2)

      Parameters:
        `i` - a position
        `j` - a position
      Returns:
        self
      Since:
        2.4.0

    - #### public List toList()

      Converts this array to a List of the same size, with each element added to the list.

      Returns:
        a list containing the contents of this array.
      Since:
        1.0

    - #### public Set toSet()

      Converts this array to a Set, with each unique element added to the set.

      Returns:
        a set containing the unique contents of this array.
      Since:
        1.8.0

    - #### public String toString()

      Returns the string representation of the given array.

      Returns:
        the string representation
      Since:
        1.6.0